var DUDEN_CORRECTOR = function(module) {
    "use strict";
    tinymce.PluginManager.requireLangPack("duden");
    var EditorAdapter, INITIAL_STORAGE = {
        "text-language": "de-DE",
        "spellchecking-level": 3,
        "orthography-standard": "duden",
        "spell-check-as-you-type": !0
    }, corrector = new module.DCSCorrector(), options = ("6" === tinymce.majorVersion || "5" === tinymce.majorVersion ? EditorAdapter = module.TinyMCE5Adapter : "4" === tinymce.majorVersion ? EditorAdapter = module.TinyMCE4Adapter : "3" === tinymce.majorVersion ? EditorAdapter = module.TinyMCE3Adapter : console.error("Unsupported TinyMCE version found."), 
    console.log("TinyMCE version " + tinymce.majorVersion + " detected"), {
        proposeWordFunction: function(word, callbacks) {
            corrector.proposeWordForDictionary(word, callbacks);
        },
        isProposalPendingFunction: function(word, callback) {
            corrector.isProposalPending(word, callback);
        }
    });
    EditorAdapter.installPlugin(INITIAL_STORAGE, options, "duden", function(adapter, corrector, storage) {
        return {
            icon: !0,
            context: "tools",
            menu: [ {
                text: adapter.translate("menu.start_correction"),
                icon: !1,
                onclick: function() {
                    triggerCheck(adapter, corrector);
                }
            }, {
                text: adapter.translate("menu.remove_error_markup"),
                icon: !1,
                onclick: function() {
                    adapter.removeErrorMarkup();
                }
            }, {
                text: "-"
            }, {
                text: adapter.translate("menu.auto_spell_check"),
                selectable: !0,
                onclick: function() {
                    var newState = !storage.get("spell-check-as-you-type");
                    storage.set("spell-check-as-you-type", newState), newState || adapter.removeErrorMarkup(), 
                    adapter.showMessageToast(adapter.translate(newState ? "messages.auto_spellcheck_activated" : "messages.auto_spellcheck_deactivated"));
                },
                isSelected: function() {
                    return storage.get("spell-check-as-you-type");
                }
            }, {
                text: "-"
            }, {
                text: adapter.translate("menu.dictionary_proposal"),
                icon: !1,
                onclick: function() {
                    adapter.showDictionaryProposalDialog();
                }
            }, {
                text: "-"
            }, {
                text: adapter.translate("menu.dictionary_settings"),
                icon: !1,
                onclick: function() {
                    adapter.showSettingsDialog();
                }
            } ]
        };
    }, corrector, function(adapter, editor, url) {
        console.log("Initializing Duden TinyMCE Plug-in (Version: 1.5.8)"), adapter.on("init", function() {
            !function(editor, url) {
                {
                    var head;
                    editor.getDoc().getElementById("duden-style") || (head = editor.getDoc().getElementsByTagName("head")[0], 
                    (editor = editor.getDoc().createElement("link")).setAttribute("rel", "stylesheet"), 
                    editor.setAttribute("type", "text/css"), editor.setAttribute("href", url + "/css/style.css"), 
                    editor.setAttribute("id", "duden-style"), head.insertBefore(editor, head.firstChild));
                }
            }(editor, url), corrector.getVersion({
                success: function(data) {
                    data ? (console.log("Connected to Duden Correction Server: " + JSON.stringify(data)), 
                    editor.getParam("duden_enable_spell_check_on_init") && triggerCheck(adapter, corrector)) : adapter.showMessageToast(adapter.translate("messages.connection_failed"), "error");
                }
            });
        }), corrector.proxy_without_parameter = editor.getParam("duden_proxy_without_parameter");
        var proxyScriptUrl = editor.getParam("duden_proxy_script_url") || adapter.url + "/php/duden-correction-server-connector.php", allowNestedErrors = editor.getParam("duden_allow_nested_errors") || !0, allowNestedErrors = {
            proposalDictionary: editor.getParam("duden_proposal_dictionary") || "Proposals",
            dictionaries: editor.getParam("duden_dictionaries"),
            allowNestedErrors: allowNestedErrors
        };
        corrector.init(proxyScriptUrl, adapter.storage, allowNestedErrors), adapter.enableMarkupRemoval = editor.getParam("duden_enable_markup_removal") || !1, 
        function(adapter) {
            adapter.on("contextmenu", function(event) {
                var checkPosition, message, showDictionaryOptions, showIgnoreOptions, clickedMistakeSpan = function(target) {
                    for (;target.parentNode && -1 === target.className.indexOf("mce-content-body"); ) {
                        if (0 === target.className.indexOf("duden-typo") && -1 === target.className.indexOf("duden-typo-disabled")) return target;
                        target = target.parentNode;
                    }
                }(event.target);
                clickedMistakeSpan && (event.preventDefault(), checkPosition = JSON.parse(clickedMistakeSpan.getAttribute("data-duden-checkPosition")), 
                clickedMistakeSpan.getAttribute("data-duden-word"), message = clickedMistakeSpan.getAttribute("data-duden-message"), 
                showDictionaryOptions = 21 == checkPosition.errorcode, showIgnoreOptions = 21 == checkPosition.errorcode, 
                adapter.showContextMenu(event, clickedMistakeSpan, message, checkPosition.proposals, showDictionaryOptions, showIgnoreOptions));
            });
            var previousWord, currentlyEditing = !1, inputEvent = adapter.getInputEventName();
            function isUserSelectionActive(adapter) {
                var selection = null;
                return "function" == typeof adapter.editor.contentWindow.getSelection ? selection = adapter.editor.contentWindow.getSelection() : "function" == typeof adapter.editor.contentDocument.getSelection && (selection = adapter.editor.contentDocument.getSelection()), 
                null !== selection && !1 === selection.isCollapsed;
            }
            function handleChangeSpellCheckAsYouType(event, adapter, corrector) {
                var topLevelNode, currentWord, wordToCheck, pressedKeyCode;
                !adapter.isSpellCheckAsYouTypeEnabled() || event.ctrlKey || 17 === event.keyCode || module.util.isSelectionEvent(event) || (currentWord = function(currentParagraph, cursorPosition, text) {
                    if (void 0 !== cursorPosition && void 0 !== currentParagraph && text) {
                        for (var currentPosition = cursorPosition; 0 < currentPosition && module.util.isWordCharacter(text.charAt(currentPosition - 1)); ) currentPosition--;
                        for (var leftBoundary = currentPosition, i = (currentPosition = cursorPosition, 
                        0); i < currentPosition; i++) 0;
                        for (;currentPosition < text.length && module.util.isWordCharacter(text.charAt(currentPosition)); ) {
                            currentPosition++;
                            for (i = 0; i < currentPosition; i++) 0;
                        }
                        cursorPosition = currentPosition;
                        return {
                            word: text.substring(leftBoundary, cursorPosition),
                            paragraph: currentParagraph,
                            start: leftBoundary,
                            end: cursorPosition
                        };
                    }
                }(topLevelNode = adapter.getTopLevelNodeOfNode(adapter.editor.selection.getNode()), adapter.getCursorPosition(), topLevelNode = adapter.getText(topLevelNode)), 
                "blur" === event.type ? (currentWord && 0 < currentWord.word.length && (wordToCheck = currentWord), 
                previousWord = void 0) : (void 0 === previousWord || currentWord && previousWord.paragraph === currentWord.paragraph && previousWord.start === currentWord.start || (wordToCheck = previousWord), 
                pressedKeyCode = event.keyCode, event.type !== inputEvent || 16 <= pressedKeyCode && pressedKeyCode <= 31 || 37 <= pressedKeyCode && pressedKeyCode <= 40 || (currentlyEditing = !0)), 
                previousWord = currentWord, wordToCheck && (topLevelNode = adapter.getText(wordToCheck.paragraph)), 
                wordToCheck && topLevelNode && wordToCheck.word === topLevelNode.substring(wordToCheck.start, wordToCheck.end) && wordToCheck && 0 < wordToCheck.word.length && currentlyEditing && (currentlyEditing = !1, 
                0 != (event = function(text, start, end) {
                    for (var i = start; 0 <= i && " " !== text.substring(i, i + 1); i--) start = i;
                    for (i = end; i < text.length && " " !== text.substring(i, i + 1); i++) end = i;
                    return text.substring(start, end).trim();
                }(wordToCheck.paragraph.textContent, wordToCheck.start, wordToCheck.end).toLowerCase()).indexOf("www") && 0 != event.indexOf("http") && 0 != event.indexOf("ftp") && function(adapter, corrector, word) {
                    adapter.hideErrorMarkupForWord(word);
                    var settings = {
                        "single-word-mode": !0,
                        "spellchecking-level": 1,
                        "text-language": adapter.getNodeLanguage(word.paragraph)
                    };
                    corrector.check(word.word, {
                        success: function(data) {
                            adapter.highlightCheckPositions(word.paragraph, data["check-positions"], data.messages, data["glossary-messages"], word.start);
                        },
                        error: function(error) {
                            console.log("Error:", error);
                        }
                    }, settings, !0);
                }(adapter, corrector, wordToCheck)));
            }
            adapter.on("input keyup blur click", function(event) {
                isUserSelectionActive(adapter) || handleChangeSpellCheckAsYouType(event, adapter, corrector);
            }), adapter.on("input keyup blur click mouseup", function(event) {
                isUserSelectionActive(adapter) || adapter.refreshSelectedLanguage();
            }), adapter.on("keyup", function() {
                isUserSelectionActive(adapter) || !function(adapter) {
                    adapter.editor.dom.select(adapter.markupElement + ".duden-typo").forEach(function(mistakeSpan) {
                        !function(mistakeSpan) {
                            var word = mistakeSpan.textContent, originalWord = mistakeSpan.getAttribute("data-duden-word");
                            if (word !== originalWord) return 1;
                            if (mistakeSpan.previousSibling) {
                                originalWord = mistakeSpan.previousSibling.textContent.slice(-1);
                                if (module.util.isAlphaNumeric(originalWord) && module.util.isAlphaNumeric(word.charAt(0))) return 1;
                            }
                            if (mistakeSpan.nextSibling) return originalWord = mistakeSpan.nextSibling.textContent.charAt(0), 
                            module.util.isAlphaNumeric(originalWord) && module.util.isAlphaNumeric(word.slice(-1)) ? 1 : void 0;
                        }(mistakeSpan) || (mistakeSpan.className = "duden-typo-disabled");
                    }.bind(this));
                }(adapter);
            }), adapter.on("paste", function() {
                adapter.isSpellCheckAsYouTypeEnabled() && !function(adapter, corrector) {
                    checkTimeoutHandle && window.clearTimeout(checkTimeoutHandle);
                    checkTimeoutHandle = setTimeout(function() {
                        triggerCheck(adapter, corrector, SINGLE_WORD_SETTINGS);
                    }, CHECK_TIMEOUT_IN_MS);
                }(adapter, corrector);
            });
        }(adapter), function(adapter, corrector) {
            "5" === tinymce.majorVersion || "6" === tinymce.majorVersion ? (adapter.editor.ui.registry.addIcon("dudenIcon", '<svg width="20" height="20"><rect width="20" height="20" ry="2.55"/><path fill="#bf0c2c" d="M18.93 17.6H1.03v1.52h17.9z"/><path fill="#fff" d="M8.07 1.3c-1.3 0-2.5.06-3.86.27h-.26V16.4l.26.06c1.15.1 2.5.26 3.96.26 5.89 0 8.5-3.96 8.5-7.87.04-3.65-2.66-7.55-8.6-7.55zm6.35 7.56c0 3.7-2.24 5.89-5.99 5.89-1.04 0-1.72-.05-2.3-.1V3.33c.53-.05 1.31-.1 2.1-.1 3.8 0 6.2 2.13 6.2 5.62z"/></svg>'), 
            adapter.editor.ui.registry.addButton("duden_check", {
                tooltip: adapter.translate("button.start_correction"),
                icon: "dudenIcon",
                onAction: function() {
                    triggerCheck(adapter, corrector);
                }
            }), adapter.editor.ui.registry.addIcon("dudenSettingsIcon", '<svg width="20" height="20"><rect width="20" height="20" ry="2.55"/><path fill="#bf0c2c" d="M18.93 17.6H1.03v1.52h17.9z"/><g transform="matrix(0.40000004 0 0 0.40000004 0 0)"><g transform="matrix(0.1 0 -0 -0.1 0 50)"><path d="M0 250L0 0L250 0L500 0L500 250L500 500L250 500L0 500L0 250zM259 414C 290 408 303 390 276 390C 268 390 252 381 239 371C 219 354 217 348 227 332C 237 315 235 309 215 290C 194 270 188 269 175 280C 161 292 156 290 137 266L137 266L115 239L81 274C 49 307 46 330 76 330C 84 330 110 350 133 375C 178 421 195 427 259 414zM433 382C 442 374 450 364 450 360C 450 345 358 250 344 250C 322 250 327 261 372 307C 395 331 409 350 403 350C 397 350 376 332 355 309C 335 287 316 271 312 274C 309 278 323 297 343 318C 395 372 389 383 336 331C 312 307 290 292 286 298C 278 312 387 413 403 404C 409 400 423 390 433 382zM344 211C 421 131 430 119 420 101C 414 89 402 80 392 80C 383 80 336 119 288 167L288 167L200 254L222 277C 234 290 246 300 250 300C 253 300 296 260 344 211zM191 135C 164 110 140 90 136 90C 119 90 134 118 172 157C 202 188 217 197 226 189C 235 182 226 168 191 135z" stroke="none" fill="#fff" fill-rule="nonzero" /></g></g></svg>'), 
            adapter.editor.ui.registry.addMenuButton("duden_menu", {
                tooltip: adapter.translate("button.start_correction"),
                icon: "dudenSettingsIcon",
                fetch: function(callback) {
                    callback(adapter.getToolbarMenuItems(adapter));
                }
            })) : adapter.editor.addButton("duden_check", {
                title: adapter.translate("button.start_correction"),
                icon: !1,
                image: adapter.url + "/img/duden-icon.png",
                onclick: function() {
                    triggerCheck(adapter, corrector);
                }
            });
        }(adapter, corrector);
    });
    var checkTimeoutHandle, CHECK_TIMEOUT_IN_MS = 500, SINGLE_WORD_SETTINGS = {
        "single-word-mode": !0,
        "spellchecking-level": 1
    };
    function triggerCheck(adapter, corrector, settings, onFinishedCallback) {
        var paragraphs = adapter.getTopLevelNodes();
        (paragraphs = adapter.expandListNodes(paragraphs)).forEach(function(paragraph) {
            adapter.removeErrorMarkupForNode(paragraph);
            var paragraphLanguage, text = adapter.getText(paragraph);
            text && /\S/.test(text) && (paragraphLanguage = adapter.getNodeLanguage(paragraph), 
            corrector.check(text, {
                success: function(data) {
                    var bookmark;
                    data && (bookmark = adapter.getBookmark(), adapter.highlightCheckPositions(paragraph, data["check-positions"], data.messages, data["glossary-messages"]), 
                    adapter.moveToBookmark(bookmark), void 0 !== onFinishedCallback && onFinishedCallback());
                },
                error: function(error) {
                    console.log("Error:", error), void 0 !== onFinishedCallback && onFinishedCallback();
                }
            }, module.util.mergeObjects([ settings, {
                "text-language": paragraphLanguage
            } ])));
        });
    }
    return module;
}((DUDEN_CORRECTOR = function(module) {
    "use strict";
    var FALLBACK_TEXT_LANGUAGES = [ "de-DE", "de-AT", "de-CH" ], FALLBACK_DUDEN_CORRECTION_PROFILE = [ "base" ], FALLBACK_DEFAULT_TEXT_LANGUAGE = FALLBACK_TEXT_LANGUAGES[0], GLOBAL_ID = 1;
    function TinyMCE3Adapter(storage, options) {
        module.TinyMCEAdapter.call(this, storage, options), this.ID_LANGUAGE_SELECTION_BUTTON = "duden_language_selection_" + GLOBAL_ID++, 
        this.ID_LANGUAGE_SELECTION_BUTTON_PREFIX = "editor_";
    }
    return TinyMCE3Adapter.prototype = Object.create(module.TinyMCEAdapter.prototype), 
    module.TinyMCE3Adapter = TinyMCE3Adapter.prototype.constructor = TinyMCE3Adapter, 
    (window.__adapter = TinyMCE3Adapter).installPlugin = function(storageDefaultValues, options, pluginName, buildMenuCb, corrector, callback) {
        tinymce.create("tinymce.plugins." + pluginName, {
            init: function(editor, url) {
                var defaultLanguage = editor.getParam("duden_default_text_language") || FALLBACK_DEFAULT_TEXT_LANGUAGE, corrProfile = editor.getParam("duden_correction_profile") || FALLBACK_DUDEN_CORRECTION_PROFILE;
                localStorage.setItem("text-language", JSON.stringify(defaultLanguage)), 
                localStorage.setItem("property-sets", JSON.stringify(corrProfile)), 
                storageDefaultValues["text-language"] = defaultLanguage;
                var adapter = new TinyMCE3Adapter(new module.LocalStorage(storageDefaultValues), options);
                (editor.adapter = adapter).editor = editor, adapter.corrector = corrector, 
                adapter.url = url, adapter.markupElement = editor.getParam("duden_markup_element") || "span", 
                adapter.defaultLanguage = editor.getParam("duden_default_text_language") || FALLBACK_DEFAULT_TEXT_LANGUAGE, 
                adapter.on("mousedown", adapter.hideContextMenu.bind(adapter)), 
                adapter.on("keydown", adapter.hideContextMenu.bind(adapter)), adapter.on("click", function(event) {
                    0 == event.button && adapter.hideContextMenu.bind(adapter);
                }), adapter.on("init", function() {
                    tinymce.dom.Event.add(editor.getBody(), "blur", function() {
                        setTimeout(function() {
                            adapter.hideContextMenu();
                        }, 750);
                    });
                }), callback(adapter, editor, url);
            },
            createControl: function(controlName, controlManager) {
                var adapter = controlManager.editor.adapter;
                switch (controlName) {
                  case "duden_menu":
                    return adapter.createMenu(controlManager, buildMenuCb);

                  case "duden_lang":
                    return adapter.createLanguageMenu(controlManager);
                }
            }
        }), tinymce.PluginManager.add(pluginName, tinymce.plugins[pluginName]);
    }, TinyMCE3Adapter.prototype.translate = function(text) {
        var values;
        return "[object Array]" === Object.prototype.toString.call(text) ? (values = text.slice(1), 
        this.editor.translate(text[0]).replace(/\{([0-9]+)\}/g, function($1, $2) {
            return void 0 === values[$2] ? "" : values[$2];
        })) : this.editor.translate(text);
    }, TinyMCE3Adapter.prototype.createMenu = function(controlManager, buildMenuCb) {
        var menuDefinition = buildMenuCb(this, this.corrector, this.storage), buildMenuCb = (menuDefinition.image = this.url + "/img/settings-icon.png", 
        menuDefinition.text = this.translate("menu.title"), controlManager.createMenuButton("duden_menu", {
            title: menuDefinition.text,
            image: menuDefinition.image,
            icon: !0
        }));
        return buildMenuCb.onRenderMenu.add(function(c, menu) {
            menuDefinition.menu.forEach(function(menuItemDefinition) {
                var menuItem, originalOnclick;
                "-" === menuItemDefinition.text ? menu.addSeparator() : (menuItemDefinition.selectable && (originalOnclick = menuItemDefinition.onclick, 
                menuItemDefinition.onclick = function() {
                    originalOnclick(), menuItem.setSelected(menuItemDefinition.isSelected());
                }), menuItem = menu.add({
                    title: menuItemDefinition.text,
                    icon: menuItemDefinition.icon,
                    onclick: menuItemDefinition.onclick
                }), menuItemDefinition.selectable && menuItem.setSelected(menuItemDefinition.isSelected()));
            });
        }), buildMenuCb;
    }, TinyMCE3Adapter.prototype.createLanguageMenu = function(controlManager) {
        var that = this, languageListBox = controlManager.createListBox(that.ID_LANGUAGE_SELECTION_BUTTON, {
            title: this.translate("language_selection.title"),
            onselect: function(languageCode) {
                that.getSelectedTopLevelNodes().forEach(function(topLevelNode) {
                    that.setNodeLanguage(topLevelNode, languageCode), that.editor.focus();
                }), that.refreshSelectedLanguage();
            }
        }), self = (this.languageListBox = languageListBox, this);
        return (this.editor.getParam("duden_text_languages") || FALLBACK_TEXT_LANGUAGES).forEach(function(languageCode) {
            var languageName = self.translate("language_selection." + languageCode);
            languageListBox.add(languageName, languageCode);
        }), this.editor.onInit.add(function() {
            document.getElementById(languageListBox.id + "_text").setAttribute("style", ";width:120px;");
        }), languageListBox;
    }, TinyMCE3Adapter.prototype.showDialog = function(dialogDefinition) {
        var generalDialogOptions = {
            inline: "yes",
            width: "426px",
            height: dialogDefinition.height,
            url: this.url + "/html/dialog.html"
        };
        this.editor.windowManager.open(generalDialogOptions, {
            title: dialogDefinition.title,
            body: dialogDefinition.body,
            onsubmit: function(e) {
                dialogDefinition.callback(e.data);
            }
        });
    }, TinyMCE3Adapter.prototype.refreshSelectedLanguage = function() {
        var selectedTopLevelNodes, languages, that;
        this.isAdvancedLanguageSelectionActivated() && (selectedTopLevelNodes = this.getSelectedTopLevelNodes(), 
        languages = [], that = this, selectedTopLevelNodes.forEach(function(topLevelNode) {
            topLevelNode = that.getNodeLanguage(topLevelNode);
            -1 === languages.indexOf(topLevelNode) && languages.push(topLevelNode);
        }), 1 == languages.length ? this.languageListBox.select(languages[0]) : 1 < languages.length && (this.languageListBox.select(null), 
        this.setMenuButtonCaption("language_selection.multiple")));
    }, TinyMCE3Adapter.prototype.showContextMenu = function(e, span, message, proposals, showDictionaryOptions, showIgnoreOptions) {
        var that = this;
        this.getMenuItemsArray(span, message, proposals, showDictionaryOptions, showIgnoreOptions, function(items) {
            var scroll_left, pos = tinymce.DOM.getPos(this.editor.getContentAreaContainer()), targetPos = this.editor.dom.getPos(e.target), doc = this.editor.getDoc().documentElement, proposalsMenu = (this.editor.inline ? (pos.x += targetPos.x, 
            pos.y += targetPos.y) : (scroll_left = (this.editor.getWin().pageXOffset || doc.scrollLeft) - (doc.clientLeft || 0), 
            doc = (this.editor.getWin().pageYOffset || doc.scrollTop) - (doc.clientTop || 0), 
            pos.x += targetPos.x - scroll_left, pos.y += targetPos.y - doc), this.hideContextMenu(), 
            this.editor.controlManager.createDropMenu("duden_korrektur_contextmenu"));
            items.forEach(function(item) {
                var moreProposalsMenu, originalCallback;
                null === item ? proposalsMenu.addSeparator() : item.menu ? (moreProposalsMenu = proposalsMenu.addMenu({
                    title: item.title
                }), item.menu.forEach(function(subItem) {
                    var originalCallback;
                    moreProposalsMenu.add(subItem), subItem.onclick && (originalCallback = subItem.onclick, 
                    subItem.onclick = function() {
                        originalCallback(), that.hideContextMenu();
                    });
                })) : (proposalsMenu.add(item).setDisabled(item.disabled), item.callback && (originalCallback = item.callback, 
                item.callback = function() {
                    originalCallback(), that.hideContextMenu();
                }));
            }), proposalsMenu.showMenu(pos.x, pos.y + e.target.offsetHeight);
        }.bind(this));
    }, TinyMCE3Adapter.prototype.hideContextMenu = function() {
        var contextMenu = this.editor.controlManager.get("duden_korrektur_contextmenu");
        contextMenu && (contextMenu.removeAll(), contextMenu.destroy());
    }, TinyMCE3Adapter.prototype.getMenuItemsArray = function(span, message, proposals, showDictionaryOptions, showIgnoreOptions, callback) {
        this.editor;
        for (var items = [], i = (proposals = proposals || [], items.push({
            title: message,
            disabled: !0,
            textStyle: "font-weight:bold; color:black;"
        }), items.push(null), 0); i < proposals.length && i < 5; i++) items.push(this.generateMenuItem(span, proposals[i]));
        for (var additionalItems = [], i = 5; i < proposals.length; i++) additionalItems.push(this.generateMenuItem(span, proposals[i]));
        if (proposals.length ? additionalItems.length && (1 === additionalItems.length ? items.push(additionalItems[0]) : (items.push(null), 
        items.push({
            title: this.translate("menu.more_proposals"),
            menu: additionalItems
        }))) : items.push({
            title: this.translate("menu.no_proposals"),
            disabled: !0
        }), this.enableMarkupRemoval && (items.push(null), items.push({
            title: this.translate("menu.remove_this_markup"),
            onclick: function() {
                this.removeSingleMarkup(span);
            }.bind(this)
        })), (showIgnoreOptions || showDictionaryOptions) && items.push(null), showIgnoreOptions && (items.push({
            title: this.translate("menu.ignore"),
            onclick: function() {
                this.ignoreWord(span, !1);
            }.bind(this)
        }), items.push({
            title: this.translate("menu.ignore_all"),
            onclick: function() {
                this.ignoreWord(span, !0);
            }.bind(this)
        })), !showDictionaryOptions || !this.options.proposeWordFunction) return callback(items);
        var word = span.textContent, notPendingItem = {
            title: this.translate("menu.dictionary_proposal"),
            onclick: function() {
                this.proposeWordForDictionary(word), this.ignoreWord(span, !0);
            }.bind(this)
        };
        if (!this.options.isProposalPendingFunction) return items.push(notPendingItem), 
        callback(items);
        var self = this;
        this.options.isProposalPendingFunction(word, function(isPending) {
            return isPending ? items.push({
                title: self.translate("menu.pending_proposal"),
                disabled: !0
            }) : items.push(notPendingItem), callback(items);
        });
    }, TinyMCE3Adapter.prototype.generateMenuItem = function(span, proposal) {
        var titleStr = "", isDisabled = !1;
        return span.classList.contains("duden-typo-discont") && (titleStr = "* ", 
        isDisabled = !0), {
            title: titleStr += proposal,
            disabled: isDisabled,
            onclick: function() {
                this.applyProposal(span, proposal);
            }.bind(this)
        };
    }, TinyMCE3Adapter.prototype.on = function(eventNames, callback) {
        var editor = this.editor, listener = {
            init: editor.onInit,
            click: editor.onClick,
            keyup: editor.onKeyUp,
            keydown: editor.onKeyDown,
            mouseup: editor.onMouseUp,
            mousedown: editor.onMouseDown,
            paste: editor.onPaste,
            contextmenu: editor.onContextMenu
        };
        eventNames.split(" ").forEach(function(eventName) {
            listener[eventName] ? listener[eventName].add(function(_, event) {
                callback(event);
            }) : "blur" === eventName && editor.onInit.add(function() {
                tinymce.dom.Event.add(editor.getBody(), "blur", callback);
            });
        }.bind(this));
    }, TinyMCE3Adapter.prototype.getInputEventName = function() {
        return "keyup";
    }, module;
}((DUDEN_CORRECTOR = function(module) {
    "use strict";
    var FALLBACK_TEXT_LANGUAGES = [ "de-DE", "de-AT", "de-CH" ], FALLBACK_DUDEN_CORRECTION_PROFILE = [ "base" ], FALLBACK_DEFAULT_TEXT_LANGUAGE = FALLBACK_TEXT_LANGUAGES[0], GLOBAL_ID = 1;
    function TinyMCE4Adapter(storage, options) {
        module.TinyMCEAdapter.call(this, storage, options), this.ID_LANGUAGE_SELECTION_BUTTON = "duden_language_selection_" + GLOBAL_ID++, 
        this.ID_LANGUAGE_SELECTION_BUTTON_PREFIX = "";
    }
    return TinyMCE4Adapter.prototype = Object.create(module.TinyMCEAdapter.prototype), 
    (module.TinyMCE4Adapter = TinyMCE4Adapter.prototype.constructor = TinyMCE4Adapter).installPlugin = function(storageDefaultValues, options, pluginName, buildMenuCb, corrector, callback) {
        tinymce.PluginManager.add(pluginName, function(editor, url) {
            var defaultLanguage = editor.getParam("duden_default_text_language") || FALLBACK_DEFAULT_TEXT_LANGUAGE, corrProfile = editor.getParam("duden_correction_profile") || FALLBACK_DUDEN_CORRECTION_PROFILE, corrProfile = (localStorage.setItem("text-language", JSON.stringify(defaultLanguage)), 
            localStorage.setItem("property-sets", JSON.stringify(corrProfile)), 
            storageDefaultValues["text-language"] = defaultLanguage, new module.LocalStorage(storageDefaultValues)), defaultLanguage = new TinyMCE4Adapter(corrProfile, options), corrProfile = (defaultLanguage.editor = editor, 
            defaultLanguage.url = url, defaultLanguage.markupElement = editor.getParam("duden_markup_element") || "span", 
            defaultLanguage.defaultLanguage = editor.getParam("duden_default_text_language") || FALLBACK_DEFAULT_TEXT_LANGUAGE, 
            buildMenuCb(defaultLanguage, corrector, corrProfile));
            corrProfile.image = url + "/img/duden-icon.png", corrProfile.text = defaultLanguage.translate("menu.title"), 
            editor.addMenuItem(corrProfile.text, defaultLanguage.createMenu(corrProfile)), 
            defaultLanguage.createLanguageMenu(), callback(defaultLanguage, editor, url);
        });
    }, TinyMCE4Adapter.prototype.translate = function(text) {
        return "string" != typeof text ? (console.warn("Text to translate is no string: ", text), 
        "") : this.editor.translate(text);
    }, TinyMCE4Adapter.prototype.createMenu = function(menuDefinition) {
        return menuDefinition.menu.forEach(function(menuItemDefinition) {
            var originalOnclick;
            menuItemDefinition.selectable && (originalOnclick = menuItemDefinition.onclick, 
            menuItemDefinition.onclick = function() {
                originalOnclick(), this.active(menuItemDefinition.isSelected());
            }, menuItemDefinition.active = menuItemDefinition.isSelected());
        }), menuDefinition;
    }, TinyMCE4Adapter.prototype.createLanguageMenu = function() {
        var languageIdx, languages = this.editor.getParam("duden_text_languages") || FALLBACK_TEXT_LANGUAGES, defaultLanguage = this.editor.getParam("duden_default_text_language") || FALLBACK_DEFAULT_TEXT_LANGUAGE, languageOptions = [], that = this;
        for (languageIdx in languages) {
            var languageCode = languages[languageIdx];
            languageOptions.push({
                text: this.translate("language_selection." + languageCode),
                languageCode: languageCode,
                selectable: !0,
                icon: !1,
                onClick: function(languageCode) {
                    return function() {
                        return that.getSelectedTopLevelNodes().forEach(function(topLevelNode) {
                            that.setNodeLanguage(topLevelNode, languageCode), that.editor.focus();
                        }), that.refreshSelectedLanguage(), !0;
                    };
                }(languageCode)
            });
        }
        this.editor.addButton("duden_lang", {
            type: "menubutton",
            title: this.translate("language_selection.title"),
            text: this.translate("language_selection." + defaultLanguage),
            icon: !1,
            menu: languageOptions,
            id: that.ID_LANGUAGE_SELECTION_BUTTON
        });
    }, TinyMCE4Adapter.prototype.showDialog = function(dialogDefinition) {
        this.editor.windowManager.open({
            title: dialogDefinition.title,
            body: dialogDefinition.body,
            onsubmit: function(e) {
                dialogDefinition.callback(e.data);
            }.bind(this)
        });
    }, TinyMCE4Adapter.prototype.refreshSelectedLanguage = function() {
        var languages, that, selectedTopLevelNodes;
        this.isAdvancedLanguageSelectionActivated() && (selectedTopLevelNodes = this.getSelectedTopLevelNodes(), 
        languages = [], that = this, selectedTopLevelNodes.forEach(function(topLevelNode) {
            topLevelNode = that.getNodeLanguage(topLevelNode);
            -1 === languages.indexOf(topLevelNode) && languages.push(topLevelNode);
        }), selectedTopLevelNodes = 1 < languages.length ? this.translate("language_selection.multiple") : this.translate("language_selection." + (languages[0] || this.defaultLanguage)), 
        this.setMenuButtonCaption(selectedTopLevelNodes));
    }, TinyMCE4Adapter.prototype.showContextMenu = function(e, span, message, proposals, showDictionaryOptions, showIgnoreOptions) {
        this.getMenuItemsArray(span, message, proposals, showDictionaryOptions, showIgnoreOptions, function(items) {
            var pos, targetPos, scroll_left, doc;
            this.editor.plugins.contextmenu ? editor.rendercontextmenu(e, items) : ((items = new tinymce.ui.Menu({
                items: items,
                context: "contextmenu"
            })).renderTo(document.body), pos = tinymce.dom.DOMUtils.DOM.getPos(this.editor.getContentAreaContainer()), 
            targetPos = this.editor.dom.getPos(e.target), doc = this.editor.getDoc().documentElement, 
            this.editor.inline ? (pos.x += targetPos.x, pos.y += targetPos.y) : (scroll_left = (this.editor.getWin().pageXOffset || doc.scrollLeft) - (doc.clientLeft || 0), 
            doc = (this.editor.getWin().pageYOffset || doc.scrollTop) - (doc.clientTop || 0), 
            pos.x += targetPos.x - scroll_left, pos.y += targetPos.y - doc), items.moveTo(pos.x, pos.y + e.target.offsetHeight));
        }.bind(this));
    }, TinyMCE4Adapter.prototype.getMenuItemsArray = function(span, message, proposals, showDictionaryOptions, showIgnoreOptions, callback) {
        this.editor;
        for (var items = [], i = (proposals = proposals || [], items.push({
            text: message,
            disabled: !0,
            textStyle: "font-weight:bold; color:black;"
        }), items.push({
            text: "-"
        }), 0); i < proposals.length && i < 5; i++) items.push(this.generateMenuItem(span, proposals[i]));
        for (var additionalItems = [], i = 5; i < proposals.length; i++) additionalItems.push(this.generateMenuItem(span, proposals[i]));
        if (proposals.length ? additionalItems.length && (1 === additionalItems.length ? items.push(additionalItems[0]) : (items.push({
            text: "-"
        }), items.push({
            text: this.translate("menu.more_proposals"),
            menu: additionalItems
        }))) : items.push({
            text: this.translate("menu.no_proposals"),
            disabled: !0
        }), this.enableMarkupRemoval && (items.push(null), items.push({
            text: this.translate("menu.remove_this_markup"),
            onclick: function() {
                this.removeSingleMarkup(span);
            }.bind(this)
        })), (showIgnoreOptions || showDictionaryOptions) && items.push({
            text: "-"
        }), showIgnoreOptions && (items.push({
            text: this.translate("menu.ignore"),
            onclick: function() {
                this.ignoreWord(span, !1);
            }.bind(this)
        }), items.push({
            text: this.translate("menu.ignore_all"),
            onclick: function() {
                this.ignoreWord(span, !0);
            }.bind(this)
        })), !showDictionaryOptions || !this.options.proposeWordFunction) return callback(items);
        var word = span.textContent, notPendingItem = {
            text: this.translate("menu.dictionary_proposal"),
            onclick: function() {
                this.proposeWordForDictionary(word), this.ignoreWord(span, !0);
            }.bind(this)
        };
        if (!this.options.isProposalPendingFunction) return items.push(notPendingItem), 
        callback(items);
        var self = this;
        this.options.isProposalPendingFunction(word, function(isPending) {
            return isPending ? items.push({
                text: self.translate("menu.pending_proposal"),
                disabled: !0
            }) : items.push(notPendingItem), callback(items);
        });
    }, TinyMCE4Adapter.prototype.generateMenuItem = function(span, proposal) {
        var titleStr = "", isDisabled = !1;
        return span.classList.contains("duden-typo-discont") && (titleStr = "* ", 
        isDisabled = !0), {
            text: titleStr += proposal,
            disabled: isDisabled,
            onclick: function() {
                this.applyProposal(span, proposal);
            }.bind(this)
        };
    }, TinyMCE4Adapter.prototype.on = function(eventNames, callback) {
        this.editor.on(eventNames, callback);
    }, module;
}((DUDEN_CORRECTOR = function(module) {
    "use strict";
    var FALLBACK_TEXT_LANGUAGES = [ "de-DE", "de-AT", "de-CH" ], FALLBACK_DUDEN_CORRECTION_PROFILE = [ "base" ], FALLBACK_DEFAULT_TEXT_LANGUAGE = FALLBACK_TEXT_LANGUAGES[0], GLOBAL_ID = 1;
    function TinyMCE5Adapter(storage, options) {
        module.TinyMCEAdapter.call(this, storage, options), this.ID_LANGUAGE_SELECTION_BUTTON = "duden_language_selection_" + GLOBAL_ID++, 
        this.ID_LANGUAGE_SELECTION_BUTTON_PREFIX = "";
    }
    return TinyMCE5Adapter.prototype = Object.create(module.TinyMCEAdapter.prototype), 
    (module.TinyMCE5Adapter = TinyMCE5Adapter.prototype.constructor = TinyMCE5Adapter).installPlugin = function(storageDefaultValues, options, pluginName, buildMenuCb, corrector, callback) {
        tinymce.PluginManager.add(pluginName, function(editor, url) {
            var defaultLanguage = editor.getParam("duden_default_text_language") || FALLBACK_DEFAULT_TEXT_LANGUAGE, corrProfile = editor.getParam("duden_correction_profile") || FALLBACK_DUDEN_CORRECTION_PROFILE, corrProfile = (localStorage.setItem("text-language", JSON.stringify(defaultLanguage)), 
            localStorage.setItem("property-sets", JSON.stringify(corrProfile)), 
            storageDefaultValues["text-language"] = defaultLanguage, new module.LocalStorage(storageDefaultValues)), adapter = new TinyMCE5Adapter(corrProfile, options), defaultLanguage = (adapter.editor = editor, 
            adapter.url = url, adapter.markupElement = editor.getParam("duden_markup_element") || "span", 
            adapter.defaultLanguage = defaultLanguage, buildMenuCb(adapter, corrector, corrProfile)), corrProfile = (defaultLanguage.image = url + "/img/duden-icon.png", 
            defaultLanguage.text = adapter.translate("menu.title"), adapter.createNestedMenu(defaultLanguage));
            editor.ui.registry.addNestedMenuItem("duden", corrProfile), adapter.settingsMenuDefinition = corrProfile, 
            editor.ui.registry.addContextMenu("duden", {
                update: function(element) {
                    var message, showDictionaryOptions, showIgnoreOptions, checkPosition, element = function(target) {
                        for (;target.parentNode && -1 === target.className.indexOf("mce-content-body"); ) {
                            if (0 === target.className.indexOf("duden-typo") && -1 === target.className.indexOf("duden-typo-disabled")) return target;
                            target = target.parentNode;
                        }
                    }(element);
                    return element ? (checkPosition = JSON.parse(element.getAttribute("data-duden-checkPosition")), 
                    element.getAttribute("data-duden-word"), message = element.getAttribute("data-duden-message"), 
                    showDictionaryOptions = 21 == checkPosition.errorcode, showIgnoreOptions = 21 == checkPosition.errorcode, 
                    checkPosition = checkPosition.proposals, adapter.getMenuItemsArray(element, message, checkPosition, showDictionaryOptions, showIgnoreOptions)) : {};
                }
            }), adapter.createLanguageMenu(), callback(adapter, editor, url);
        });
    }, TinyMCE5Adapter.prototype.translate = function(text) {
        return "string" != typeof text ? (console.warn("Text to translate is no string: ", text), 
        "") : this.editor.translate(text);
    }, TinyMCE5Adapter.prototype.createMenu = function(menuDefinition) {
        return menuDefinition.menu.forEach(function(menuItemDefinition) {
            var originalOnclick;
            menuItemDefinition.selectable && (originalOnclick = menuItemDefinition.onclick, 
            menuItemDefinition.onclick = function() {
                originalOnclick(), this.active(menuItemDefinition.isSelected());
            }, menuItemDefinition.active = menuItemDefinition.isSelected());
        }), menuDefinition;
    }, TinyMCE5Adapter.prototype.createNestedMenu = function(menuDefinition) {
        var newMenuDefinition = {
            text: menuDefinition.text
        }, subMenuItems = [];
        return menuDefinition.menu.forEach(function(menuItemDefinition) {
            var newMenuItemDefinition = {};
            "-" == menuItemDefinition.text ? newMenuItemDefinition.type = "separator" : menuItemDefinition.selectable ? (newMenuItemDefinition.type = "togglemenuitem", 
            newMenuItemDefinition.text = menuItemDefinition.text, newMenuItemDefinition.onAction = menuItemDefinition.onclick, 
            newMenuItemDefinition.onSetup = function(api) {
                api.setActive(menuItemDefinition.isSelected());
            }) : (newMenuItemDefinition.type = "menuitem", newMenuItemDefinition.text = menuItemDefinition.text, 
            newMenuItemDefinition.onAction = menuItemDefinition.onclick), subMenuItems.push(newMenuItemDefinition);
        }), newMenuDefinition.getSubmenuItems = function() {
            return subMenuItems;
        }, newMenuDefinition;
    }, TinyMCE5Adapter.prototype.getToolbarMenuItems = function(adapter) {
        return adapter.settingsMenuDefinition.getSubmenuItems();
    }, TinyMCE5Adapter.prototype.createLanguageMenu = function() {
        var languageIdx, languages = this.editor.getParam("duden_text_languages") || FALLBACK_TEXT_LANGUAGES, defaultLanguage = this.editor.getParam("duden_default_text_language") || FALLBACK_DEFAULT_TEXT_LANGUAGE, languageOptions = [], that = this;
        for (languageIdx in languages) {
            var languageCode = languages[languageIdx];
            languageOptions.push({
                type: "togglemenuitem",
                text: this.translate("language_selection." + languageCode),
                languageCode: languageCode,
                onAction: function() {
                    return that.getSelectedTopLevelNodes().forEach(function(topLevelNode) {
                        that.setNodeLanguage(topLevelNode, languageCode), that.editor.focus();
                    }), that.refreshSelectedLanguage(), !0;
                }
            });
        }
        this.editor.ui.registry.addMenuButton("duden_lang", {
            title: this.translate("language_selection.title"),
            text: this.translate("language_selection." + defaultLanguage),
            fetch: function(callback) {
                callback(languageOptions);
            },
            id: that.ID_LANGUAGE_SELECTION_BUTTON
        });
    }, TinyMCE5Adapter.prototype.showDialog = function(dialogDefinition) {
        var bodyItems = [], initialValues = {}, dialogConfig = (dialogDefinition.body.forEach(function(oldWidget) {
            var sbItems, newWidget;
            "listbox" == oldWidget.type ? (sbItems = [], oldWidget.values.forEach(function(oldVal) {
                sbItems.push({
                    value: String(oldVal.value),
                    text: oldVal.text
                });
            }), newWidget = {
                type: "selectbox",
                name: oldWidget.name,
                label: oldWidget.label,
                items: sbItems
            }, initialValues[newWidget.name] = String(oldWidget.value), bodyItems.push(newWidget)) : "textbox" == oldWidget.type ? (newWidget = {
                type: "input",
                name: oldWidget.name,
                label: oldWidget.label
            }, bodyItems.push(newWidget)) : bodyItems.push(oldWidget);
        }), {
            title: dialogDefinition.title,
            body: {
                type: "panel",
                items: bodyItems
            },
            buttons: [ {
                type: "submit",
                text: this.translate("Ok"),
                primary: !0
            }, {
                type: "cancel",
                text: this.translate("Cancel")
            } ],
            initialData: initialValues,
            onSubmit: function(dialogApi) {
                var newData = dialogApi.getData();
                dialogDefinition.callback(newData), dialogApi.close();
            }
        });
        this.editor.windowManager.open(dialogConfig);
    }, TinyMCE5Adapter.prototype.refreshSelectedLanguage = function() {
        var languages, that, selectedTopLevelNodes;
        this.isAdvancedLanguageSelectionActivated() && (selectedTopLevelNodes = this.getSelectedTopLevelNodes(), 
        languages = [], that = this, selectedTopLevelNodes.forEach(function(topLevelNode) {
            topLevelNode = that.getNodeLanguage(topLevelNode);
            -1 === languages.indexOf(topLevelNode) && languages.push(topLevelNode);
        }), selectedTopLevelNodes = 1 < languages.length ? this.translate("language_selection.multiple") : this.translate("language_selection." + (languages[0] || this.defaultLanguage)), 
        this.setMenuButtonCaption(selectedTopLevelNodes));
    }, TinyMCE5Adapter.prototype.showContextMenu = function(e, span, message, proposals, showDictionaryOptions, showIgnoreOptions) {
        this.getMenuItemsArray(span, message, proposals, showDictionaryOptions, showIgnoreOptions, function(items) {
            this.editor.rendercontextmenu(e, items);
        }.bind(this));
    }, TinyMCE5Adapter.prototype.getMenuItemsArray = function(span, message, proposals, showDictionaryOptions, showIgnoreOptions) {
        for (var items = [], i = (proposals = proposals || [], this.editor.ui.registry.addMenuItem("message", {
            text: message,
            disabled: !0
        }), items.push("message"), items.push({
            type: "separator"
        }), 0); i < proposals.length && i < 5; i++) items.push(this.generateMenuItem(span, proposals[i]));
        for (var additionalItems = [], i = 5; i < proposals.length; i++) additionalItems.push(this.generateMenuItem(span, proposals[i]));
        if (proposals.length ? additionalItems.length ? 1 === additionalItems.length ? items.push(additionalItems[0]) : (items.push({
            type: "separator"
        }), items.push({
            type: "submenu",
            text: this.translate("menu.more_proposals"),
            getSubmenuItems: function() {
                return additionalItems;
            }
        })) : this.enableMarkupRemoval && (items.push({
            type: "separator"
        }), items.push({
            type: "menuitem",
            text: this.translate("menu.remove_this_markup"),
            onAction: function() {
                this.removeSingleMarkup(span);
            }.bind(this)
        })) : (this.editor.ui.registry.addMenuItem("no_proposals", {
            text: this.translate("menu.no_proposals"),
            disabled: !0
        }), items.push("no_proposals")), (showIgnoreOptions || showDictionaryOptions) && items.push({
            type: "separator"
        }), showIgnoreOptions && (items.push({
            type: "menuitem",
            text: this.translate("menu.ignore"),
            onAction: function() {
                this.ignoreWord(span, !1);
            }.bind(this)
        }), items.push({
            type: "menuitem",
            text: this.translate("menu.ignore_all"),
            onAction: function() {
                this.ignoreWord(span, !0);
            }.bind(this)
        })), !showDictionaryOptions || !this.options.proposeWordFunction) return items;
        var word = span.textContent, message = {
            type: "menuitem",
            text: this.translate("menu.dictionary_proposal"),
            onAction: function() {
                this.proposeWordForDictionary(word), this.ignoreWord(span, !0);
            }.bind(this)
        };
        return items.push(message), items;
    }, TinyMCE5Adapter.prototype.generateMenuItem = function(span, proposal) {
        var titleStr = "";
        return span.classList.contains("duden-typo-discont") && (titleStr = "* "), 
        {
            type: "menuitem",
            text: titleStr += proposal,
            onAction: function() {
                this.applyProposal(span, proposal);
            }.bind(this)
        };
    }, TinyMCE5Adapter.prototype.on = function(eventNames, callback) {
        "contextmenu" != eventNames && this.editor.on(eventNames, callback);
    }, module;
}((DUDEN_CORRECTOR = function(module) {
    "use strict";
    var TOP_LEVEL_TAGS = [ "p", "div", "blockquote", "pre", "h1", "h2", "h3", "h4", "h5", "h6", "ul", "ol" ];
    function TinyMCEAdapter(storage, options) {
        this.storage = storage, this.options = options;
    }
    return (module.TinyMCEAdapter = TinyMCEAdapter).prototype.getText = function(node) {
        if (node.innerText) return text = (text = node.innerText).replaceAll("-\n", "­­");
        node = node.innerHTML;
        if (!node) return "";
        var text = node.replace(/<br *\/? *>/g, "\n");
        return text = module.util.removeHTMLMarkup(text), text = module.util.decodeHTML(text);
    }, TinyMCEAdapter.prototype.iterTextNodes = function(node, applyFunction, finishedFunction) {
        var i, lineBreakIndices = module.util.getIndicesOf("\n", this.getText(node)), textNodes = this.getTextNodes(node), currentOffset = 0;
        for (i in textNodes) {
            for (;lineBreakIndices[0] === currentOffset; ) currentOffset++, lineBreakIndices.shift();
            var textNode = textNodes[i];
            if (!1 === applyFunction(textNode, currentOffset)) break;
            currentOffset += textNode.data.length;
        }
        finishedFunction && finishedFunction();
    }, TinyMCEAdapter.prototype.getTextNodes = function(paragraph) {
        var textNodes = [];
        return function findTextNodesRecursively(elem) {
            for (const child of elem.childNodes) 3 == child.nodeType && textNodes.push(child), 
            !module.util.isCDATA(child) && child.childNodes && findTextNodesRecursively(child);
        }(paragraph), textNodes;
    }, TinyMCEAdapter.prototype.getTopLevelNodes = function() {
        var nodes = [], elem = this.editor.getBody();
        return function(elem) {
            for (const child of elem.childNodes) child.tagName && -1 !== TOP_LEVEL_TAGS.indexOf(child.tagName.toLowerCase()) && nodes.push(child);
        }(elem), 0 == nodes.length && nodes.push(elem), nodes;
    }, TinyMCEAdapter.prototype.expandListNodes = function(nodes) {
        var expandedNodes = [];
        for (const listRootNode of nodes) {
            var tagName = listRootNode.tagName.toLowerCase();
            if ("ul" == tagName || "ol" == tagName) for (const listElement of listRootNode.children) "li" == listElement.tagName.toLowerCase() && expandedNodes.push(listElement); else expandedNodes.push(listRootNode);
        }
        return expandedNodes;
    }, TinyMCEAdapter.prototype.checkElement = function(elem, currentOffset, start, length, nodeListList) {
        for (var startOffset = currentOffset, nodeList = new Array(), child = elem.firstChild; child && currentOffset < start + length; child = child.nextSibling) {
            var oldLen = nodeListList.length;
            currentOffset += this.checkNode(child, currentOffset, start, length, nodeList, nodeListList), 
            oldLen != nodeListList.length && 0 < nodeList.length && (nodeListList.push(nodeList), 
            nodeList = new Array());
        }
        return 0 < nodeList.length && nodeListList.push(nodeList), currentOffset - startOffset;
    }, TinyMCEAdapter.prototype.checkNode = function(node, currentOffset, start, length, nodeList, nodeListList) {
        var nodeType = node.nodeType;
        switch (nodeType) {
          case Node.ELEMENT_NODE:
            return "BR" === node.nodeName ? (start < currentOffset && currentOffset < start + length && nodeList.push(node), 
            1) : this.checkElement(node, currentOffset, start, length, nodeListList);

          case Node.ATTRIBUTE_NODE:
            return 0;

          case Node.TEXT_NODE:
            var text = node.data;
            if (currentOffset < start) {
                if (currentOffset + text.length <= start) return text.length;
                var displacement = start - currentOffset;
                return module.util.splitTextNode(node, displacement), displacement;
            }
            return start + length <= currentOffset ? text.length : (currentOffset + text.length > start + length && (module.util.splitTextNode(node, start + length - currentOffset), 
            text = node.data), nodeList.push(node), text.length);

          case Node.CDATA_SECTION_NODE:
          case Node.PROCESSING_INSTRUCTION_NODE:
          case Node.COMMENT_NODE:
          case Node.DOCUMENT_NODE:
          case Node.DOCUMENT_TYPE_NODE:
          case Node.DOCUMENT_FRAGMENT_NODE:
            return 0;

          default:
            return console.log("Oops: Unknow node type " + nodeType), 0;
        }
    }, TinyMCEAdapter.prototype.insertErrorMarkup = function(elem, checkPosition, message) {
        var editor, cls, nodeListList = new Array(), start = checkPosition.offset, length = checkPosition.length, word = this.getText(elem).substr(checkPosition.offset, checkPosition.length), elem = (this.checkElement(elem, 0, start, length, nodeListList), 
        nodeListList.length);
        0 === nodeListList.length ? console.warn("No nodes selected for range: " + start + "," + length) : (editor = this.editor, 
        cls = "duden-typo duden-typo-" + checkPosition.type, 1 < elem && (cls += " duden-typo-discont"), 
        nodeListList.forEach(function(nodeList) {
            var span = editor.dom.create(this.markupElement, {
                class: cls,
                "data-mce-bogus": 1,
                "data-duden-word": word,
                "data-duden-checkPosition": JSON.stringify(checkPosition),
                "data-duden-message": message
            }), firstNode = nodeList[0];
            for (firstNode.parentNode.insertBefore(span, firstNode); firstNode; firstNode = nodeList.shift()) span.appendChild(firstNode);
        }.bind(this)));
    }, TinyMCEAdapter.prototype.highlightCheckPositions = function(paragraph, checkPositions, messages, glossaryMessages, offset) {
        checkPositions && (module.util.normalizeTextNodes(this.editor.getBody()), 
        checkPositions.forEach(function(checkPosition) {
            var propcode;
            "glossary" == checkPosition.type ? (propcode = checkPosition.proposals[0], 
            propcode = glossaryMessages[propcode], checkPosition.proposals = []) : propcode = messages[checkPosition.errorcode], 
            offset && (checkPosition.offset += offset), this.insertErrorMarkup(paragraph, checkPosition, propcode);
        }.bind(this)));
    }, TinyMCEAdapter.prototype.old_highlightCheckPositions = function(paragraph, checkPositions, messages, offset) {
        var text;
        checkPositions && (module.util.normalizeTextNodes(this.editor.getBody()), 
        text = this.getText(paragraph), checkPositions.forEach(function(checkPosition) {
            offset && (checkPosition.offset += offset);
            var word = text.substr(checkPosition.offset, checkPosition.length), message = messages[checkPosition.errorcode];
            this.highlightCheckPosition(paragraph, checkPosition, word, message);
        }.bind(this)), module.util.normalizeTextNodes(this.editor.getBody()));
    }, TinyMCEAdapter.prototype.findLimitingNode = function(textNode, paragraph) {
        for (var limit = textNode.parentNode; limit.parentNode && limit.parentNode !== paragraph; ) limit = limit.parentNode;
        return limit;
    }, TinyMCEAdapter.prototype.highlightCheckPosition = function(paragraph, checkPosition, word, message) {
        console.warn("Deprecated usage of highlightCheckPosition");
        var textNodes = [], curOffset = 0;
        this.iterTextNodes(paragraph, function(textNode, textNodeOffset) {
            textNodeOffset += curOffset;
            var text = textNode.data, shouldNodeBeSplitted = textNode.parentNode && textNode.parentNode !== paragraph && -1 != TOP_LEVEL_TAGS.indexOf(textNode.parentNode.name);
            if (module.util.spansOverlap(textNodeOffset, text.length, checkPosition.offset, checkPosition.length)) {
                if (textNodeOffset < checkPosition.offset && (beforeLength = checkPosition.offset - textNodeOffset, 
                shouldNodeBeSplitted ? (limit = this.findLimitingNode(textNode, paragraph), 
                curOffset += textNode.data.length, module.util.splitNode(textNode, beforeLength, limit)) : (cursorSnapshot = module.util.removeCursorOnSafari(this.editor), 
                textNode = textNode.splitText(beforeLength), curOffset += textNode.data.length, 
                module.util.setCursor(this.editor, cursorSnapshot)), textNodeOffset += beforeLength, 
                text = textNode.data), textNodeOffset + text.length > checkPosition.offset + checkPosition.length) {
                    var beforeLength = textNodeOffset + text.length - (checkPosition.offset + checkPosition.length);
                    if (shouldNodeBeSplitted) {
                        for (var limit = this.findLimitingNode(textNode, paragraph), newNode = (module.util.splitNode(textNode, text.length - beforeLength, limit), 
                        limit.previousSibling); newNode.lastChild; ) newNode = newNode.lastChild;
                        textNode = newNode;
                    } else {
                        var cursorSnapshot = module.util.removeCursorOnSafari(this.editor);
                        textNode.splitText(text.length - beforeLength), module.util.setCursor(this.editor, cursorSnapshot);
                    }
                    return textNodes.push(textNode), !1;
                }
                if (textNodeOffset + text.length == checkPosition.offset + checkPosition.length && shouldNodeBeSplitted) {
                    for (limit = this.findLimitingNode(textNode, paragraph), newNode = (module.util.splitNode(textNode, text.length, limit), 
                    limit.previousSibling); newNode.lastChild; ) newNode = newNode.lastChild;
                    textNode = newNode;
                }
                if (textNodes.push(textNode), textNodeOffset + textNode.length === checkPosition.offset + checkPosition.length) return !1;
            }
        }.bind(this), function() {
            for (var editor = this.editor, mistakeSpan = (textNodes[0], editor.dom.create(this.markupElement, {
                class: "duden-typo duden-typo-" + checkPosition.type,
                "data-mce-bogus": 1,
                "data-duden-word": word,
                "data-duden-checkPosition": JSON.stringify(checkPosition),
                "data-duden-message": message
            })), i = 0; i < textNodes.length; i++) module.util.wrap(textNodes[i], mistakeSpan);
        }.bind(this));
    }, TinyMCEAdapter.prototype.hideErrorMarkupForWord = function(word) {
        return this.removeErrorMarkupForNode(word.paragraph, word, !0);
    }, TinyMCEAdapter.prototype.removeErrorMarkupForNode = function(paragraph, word, hide) {
        for (var finished = !1; !finished; ) for (var nodes, wordMatches, checkPosition, node, finished = !0, i = (nodes = paragraph.getElementsByTagName(this.markupElement)).length; i--; ) 0 === (node = nodes[i]).className.indexOf("duden-typo") && (wordMatches = !1, 
        word ? (node.getAttribute("data-duden-word"), (checkPosition = JSON.parse(node.getAttribute("data-duden-checkPosition"))).offset == word.start && word.start + checkPosition.length == word.end && (wordMatches = !0)) : wordMatches = !0, 
        wordMatches && (hide ? node.className = "duden-typo-disabled" : (module.util.unwrapNode(node), 
        module.util.removeNode(node), finished = !1)));
    }, TinyMCEAdapter.prototype.ignoreWord = function(span, all) {
        var ignoredPosition = span, word = span.getAttribute("data-duden-word");
        this.editor.dom.select(this.markupElement + ".duden-typo").forEach(function(otherSpan) {
            var checkPosition;
            otherSpan.getAttribute("data-duden-word") == word && (checkPosition = otherSpan.getAttribute("data-duden-checkPosition"), 
            (ignoredPosition === otherSpan || all && 21 === JSON.parse(checkPosition).errorcode) && this.editor.dom.remove(otherSpan, !0));
        }.bind(this));
    }, TinyMCEAdapter.prototype.applyProposal = function(span, replacement) {
        if (!span.classList.contains("duden-typo-discont") && !span.classList.contains("duden-typo-glossary")) {
            var checkPosition = span.getAttribute("data-duden-checkPosition"), word = span.getAttribute("data-duden-word"), children = Array.prototype.slice.call(span.childNodes);
            if (0 < children.length) {
                var restLength, continuation, nodeIdx, checkPosition = JSON.parse(checkPosition), simplifiedCheckPosition = module.util.simplifyProposal(checkPosition.offset, checkPosition.length, word, replacement), curOffset = checkPosition.offset, errorOffset = simplifiedCheckPosition.offset;
                for (nodeIdx in children) {
                    var prefixLength, suffixLength, newText, node = children[nodeIdx], text = node.textContent, spanLength = text.length;
                    continuation ? ((newText = node.textContent.substring(restLength)) != node.textContent && (node.textContent = newText), 
                    restLength -= spanLength) : curOffset <= errorOffset && errorOffset <= curOffset + spanLength && (suffixLength = spanLength - (prefixLength = errorOffset - curOffset) - simplifiedCheckPosition.length, 
                    newText = text.substring(0, prefixLength) + simplifiedCheckPosition.replacement + text.substring(spanLength - suffixLength), 
                    node.textContent = newText, restLength = simplifiedCheckPosition.length - spanLength + prefixLength, 
                    continuation = !0), curOffset += spanLength;
                }
                this.editor.dom.remove(span, !0);
            }
            this.editor.undoManager.add();
        }
    }, TinyMCEAdapter.prototype.createListBox = function(name, label, defaultValue, values) {
        var valueObjects = [];
        return values.forEach(function(valueLabel) {
            valueObjects.push({
                value: valueLabel[0],
                text: valueLabel[1]
            });
        }), {
            type: "listbox",
            name: name,
            label: label,
            value: defaultValue,
            values: valueObjects
        };
    }, TinyMCEAdapter.prototype.showSettingsDialog = function() {
        var dialogElements = [ this.createListBox("spellchecking-level", this.translate("dialog.settings.spellcheck_level"), this.storage.get("spellchecking-level"), [ [ 1, this.translate("dialog.settings.spellcheck_level.1") ], [ 2, this.translate("dialog.settings.spellcheck_level.2") ], [ 3, this.translate("dialog.settings.spellcheck_level.3") ] ]), this.createListBox("orthography-standard", this.translate("dialog.settings.orthography_standard"), this.storage.get("orthography-standard"), [ [ "duden", this.translate("dialog.settings.orthography_standard.duden") ], [ "conservative", this.translate("dialog.settings.orthography_standard.conservative") ], [ "progressive", this.translate("dialog.settings.orthography_standard.progressive") ], [ "extended", this.translate("dialog.settings.orthography_standard.extended") ], [ "press", this.translate("dialog.settings.orthography_standard.press") ] ]) ];
        this.isAdvancedLanguageSelectionActivated() || dialogElements.unshift(this.createListBox("text-language", this.translate("language_selection.title"), this.storage.get("text-language"), [ [ "de-DE", this.translate("language_selection.de-DE") ], [ "de-AT", this.translate("language_selection.de-AT") ], [ "de-CH", this.translate("language_selection.de-CH") ] ])), 
        this.showDialog({
            title: this.translate("dialog.settings.title"),
            body: dialogElements,
            callback: function(data) {
                this.storage.update(data), this.showMessageToast(this.translate("messages.settings_saved"));
            }.bind(this),
            height: "150px"
        });
    }, TinyMCEAdapter.prototype.showDictionaryProposalDialog = function() {
        this.showDialog({
            title: this.translate("dialog.proposal.title"),
            body: [ {
                type: "textbox",
                name: "proposal",
                label: "",
                value: ""
            } ],
            callback: function(e) {
                e = e.proposal.trim();
                0 < e.length && this.proposeWordForDictionary(e);
            }.bind(this),
            height: "100px"
        });
    }, TinyMCEAdapter.prototype.proposeWordForDictionary = function(word, callbacks) {
        callbacks = callbacks || {}, this.options.proposeWordFunction(word, {
            success: function() {
                this.showMessageToast([ this.translate("messages.word_proposed.success"), word ], "success"), 
                callbacks.success && callbacks.success();
            }.bind(this),
            error: function() {
                this.showMessageToast([ this.translate("messages.word_proposed.error"), word ], "error"), 
                callbacks.error && callbacks.error();
            }.bind(this)
        });
    }, TinyMCEAdapter.prototype.removeErrorMarkup = function() {
        this.getTopLevelNodes().forEach(function(paragraph) {
            this.removeErrorMarkupForNode(paragraph);
        }.bind(this));
    }, TinyMCEAdapter.prototype.removeSingleMarkup = function(node) {
        module.util.unwrapNode(node), module.util.removeNode(node);
    }, TinyMCEAdapter.prototype.getSelectedTopLevelNodes = function() {
        var i, firstTopLevelNode = this.getTopLevelNodeOfNode(this.editor.selection.getStart()), lastTopLevelNode = this.getTopLevelNodeOfNode(this.editor.selection.getEnd()), insideSelection = !1, selectedTopLevelNodes = [], topLevelNodes = this.getTopLevelNodes();
        for (i in topLevelNodes = this.expandListNodes(topLevelNodes)) {
            var currentTopLevelNode = topLevelNodes[i];
            if ((insideSelection = currentTopLevelNode == firstTopLevelNode ? !0 : insideSelection) && selectedTopLevelNodes.push(currentTopLevelNode), 
            currentTopLevelNode == lastTopLevelNode) break;
        }
        return selectedTopLevelNodes;
    }, TinyMCEAdapter.prototype.getTopLevelNodeOfNode = function(node) {
        var loTagName = node.tagName.toLowerCase();
        if ("li" == loTagName || "td" == loTagName) return node;
        for (var topLevelNode = node, body = this.editor.getBody(); topLevelNode.parentNode && topLevelNode.parentNode !== body && "string" == typeof topLevelNode.parentNode.tagName && "td" !== topLevelNode.parentNode.tagName.toLowerCase() && "li" !== topLevelNode.parentNode.tagName.toLowerCase(); ) topLevelNode = topLevelNode.parentNode;
        return topLevelNode;
    }, TinyMCEAdapter.prototype.getCursorPosition = function() {
        var paragraph = this.getTopLevelNodeOfNode(this.editor.selection.getNode()), selection = this.editor.selection.getSel();
        return module.util.getRealCaretPosition(selection, paragraph);
    }, TinyMCEAdapter.prototype.getBookmark = function() {
        return this.editor.selection.getBookmark(0);
    }, TinyMCEAdapter.prototype.moveToBookmark = function(bookmark) {
        return this.editor.selection.moveToBookmark(bookmark);
    }, TinyMCEAdapter.prototype.showMessageToast = function(message, message_type) {
        var messageToast;
        "success" !== message_type && "error" !== message_type && (message_type = "info"), 
        this.editor.notificationManager ? this.editor.notificationManager.open({
            text: message,
            timeout: 3e3,
            type: message_type
        }) : (messageToast = tinymce.DOM.create("div", {
            class: "duden-message-toast",
            style: "min-width: 250px;                        margin-left: -125px;                        background-color: #333;                        color: #fff;                        text-align: center;                        border-radius: 2px;                        padding: 16px;                         position: fixed;                         z-index: 1;                        left: 50%;                         top: 30px;"
        }, message), document.body.appendChild(messageToast), setTimeout(function() {
            messageToast.parentNode.removeChild(messageToast);
        }, 3e3));
    }, TinyMCEAdapter.prototype.getNodeLanguage = function(node) {
        return this.isAdvancedLanguageSelectionActivated() ? node.getAttribute("lang") || this.defaultLanguage : this.storage.get("text-language");
    }, TinyMCEAdapter.prototype.setNodeLanguage = function(node, language) {
        this.getNodeLanguage(node) !== language && (this.removeErrorMarkupForNode(node), 
        node.setAttribute("lang", language));
    }, TinyMCEAdapter.prototype.setMenuButtonCaption = function(caption) {
        var languageButton = this.getLanguageSelectionButton();
        null !== languageButton.firstChild && "SPAN" === languageButton.firstChild.tagName ? languageButton.firstChild.innerHTML = caption : (languageButton.innerHTML = caption + " ", 
        (caption = document.createElement("I")).className = "mce-caret", languageButton.appendChild(caption));
    }, TinyMCEAdapter.prototype.isAdvancedLanguageSelectionActivated = function() {
        return null !== this.getLanguageSelectionButton();
    }, TinyMCEAdapter.prototype.getLanguageSelectionButton = function() {
        var domSelection = document.getElementById(this.ID_LANGUAGE_SELECTION_BUTTON_PREFIX + this.ID_LANGUAGE_SELECTION_BUTTON);
        return domSelection ? domSelection.firstChild : null;
    }, TinyMCEAdapter.prototype.isSpellCheckAsYouTypeEnabled = function() {
        return !0 === this.storage.get("spell-check-as-you-type");
    }, TinyMCEAdapter.prototype.getInputEventName = function() {
        return module.util.isIE() ? "keyup" : "input";
    }, module;
}((DUDEN_CORRECTOR = function(module) {
    "use strict";
    return module.util = {
        mergeObjects: function(objects) {
            var merged = {};
            return objects.forEach(function(obj) {
                for (var key in obj) obj.hasOwnProperty(key) && (merged[key] = obj[key]);
            }), merged;
        },
        isCDATA: function(elem) {
            elem = elem.nodeName.toLowerCase();
            return "script" == elem || ("style" == elem || "textarea" == elem);
        },
        getCommonSuffixLength: function(word1, word2) {
            return word1 = this.reverse(word1), word2 = this.reverse(word2), this.getCommonPrefixLength(word1, word2);
        },
        getCommonPrefixLength: function(word1, word2) {
            var i = 0, limit = (word1.length < word2.length ? word1 : word2).length;
            for (limit--; word1[i] === word2[i] && i < limit; ) i++;
            return i;
        },
        reverse: function(s) {
            return s.split("").reverse().join("");
        },
        getIndicesOf: function(searchStr, str) {
            for (var index, startIndex = 0, searchStrLen = searchStr.length, indices = []; -1 < (index = str.indexOf(searchStr, startIndex)); ) indices.push(index), 
            startIndex = index + searchStrLen;
            return indices;
        },
        spansOverlap: function(start1, length1, start2, length2) {
            return start2 <= start1 && start1 < start2 + length2 || start1 <= start2 && start2 < start1 + length1;
        },
        unwrapNode: function(node) {
            node.outerHTML = node.innerHTML;
        },
        wrap: function(node, wrapper) {
            node.parentNode.insertBefore(wrapper, node), wrapper.appendChild(node);
        },
        removeHTMLMarkup: function(s) {
            return s.replace(/<\/?[^>]+(>|$)/g, "");
        },
        decodeHTML: function(html) {
            var txt = document.createElement("textarea");
            return txt.innerHTML = html, txt.value;
        },
        normalizeTextNodes: function(elem) {
            if (elem) if (this.isIE()) for (var nextChild, child = elem.firstChild; child; ) {
                if (3 == child.nodeType) for (;(nextChild = child.nextSibling) && 3 == nextChild.nodeType; ) child.appendData(nextChild.data), 
                elem.removeChild(nextChild); else this.normalizeTextNodes(child);
                child = child.nextSibling;
            } else elem.normalize();
        },
        isIE: function() {
            var au = navigator.userAgent.toLowerCase();
            return -1 < au.indexOf("msie") || -1 < au.indexOf("trident") || -1 < au.indexOf(".net clr");
        },
        removeNode: function(textNode) {
            this.isIE() ? textNode.removeNode() : textNode.remove();
        },
        simplifyProposal: function(offset, length, word, replacement) {
            var commonPrefixLength = this.getCommonPrefixLength(word, replacement), commonPrefixLength = (commonPrefixLength && (length -= commonPrefixLength, 
            offset += commonPrefixLength, word = word.substring(commonPrefixLength), 
            replacement = replacement.substring(commonPrefixLength)), this.getCommonSuffixLength(word, replacement));
            return commonPrefixLength && (length -= commonPrefixLength, word = word.substring(0, word.length - commonPrefixLength), 
            replacement = replacement.substring(0, replacement.length - commonPrefixLength)), 
            {
                offset: offset,
                length: length,
                replacement: replacement
            };
        },
        splitNode: function(node, offset, limit) {
            var parent = limit.parentNode, parentOffset = this.getNodeIndex(parent, limit), leftRange = node.ownerDocument.createRange(), parentOffset = (leftRange.setStart(parent, parentOffset), 
            leftRange.setEnd(node, offset), leftRange.extractContents());
            return parent.insertBefore(parentOffset, limit), parentOffset;
        },
        getNodeIndex: function(parent, node) {
            for (var index = parent.childNodes.length; index-- && node !== parent.childNodes[index]; );
            return index;
        },
        isAlphaNumeric: function(string) {
            return string.match(/[a-zA-Z0-9äöüÄÖÜß]/g);
        },
        isWordCharacter: function(string) {
            return 0 < string.length && -1 === string.search(/[,;\.:!?\s\(\)\[\]\{\}\u200B-\u200D\uFEFF]/g);
        },
        encodeObjectAsURIComponents: function(obj) {
            var name, values, str = [];
            for (name in obj) obj.hasOwnProperty(name) && (Array.isArray(obj[name]) ? (values = obj[name], 
            name += "[]") : values = [ obj[name] ], values.forEach(function(value) {
                str.push(encodeURIComponent(name) + "=" + encodeURIComponent(value));
            }));
            return str.join("&");
        },
        getLanguageName: function(languageCode) {
            var languageCode = (languageCode = languageCode.toLowerCase().replace("_", "-")).split("-"), lang = {
                de: {
                    name: "Deutsch",
                    dialects: {
                        de: "Deutschland",
                        at: "Österreich",
                        ch: "Schweiz"
                    }
                },
                fr: {
                    name: "Français"
                }
            }[languageCode[0]], languageName = lang.name, languageCode = languageCode[1];
            return languageCode && (languageName += " (" + lang.dialects[languageCode] + ")"), 
            languageName;
        },
        isSelectionEvent: function(event) {
            return event.shiftKey;
        },
        walkback: function(node, stopAt) {
            if (node.childNodes && node.childNodes.length) for (;node && 0 < node.childNodes.length; ) node = node.childNodes[node.childNodes.length - 1]; else if (node.previousSibling) node = node.previousSibling; else {
                if (!node.parentNode) return;
                for (;node && !node.previousSibling && node.parentNode; ) if ((node = node.parentNode) === stopAt) return;
                if (node === stopAt) return;
                node = node.previousSibling;
            }
            if (node) return 3 === node.nodeType ? node : node === stopAt ? void 0 : this.walkback(node, stopAt);
        },
        getRealCaretPosition: function(sel, parent) {
            if (null != sel) {
                for (var pos = sel.focusOffset, node = sel.focusNode; node = this.walkback(node, parent); ) pos += node.data.length;
                return pos;
            }
        },
        isSafari: function() {
            return /^((?!chrome|android).)*safari/i.test(navigator.userAgent);
        },
        removeCursor: function(editor) {
            editor = "object" == typeof editor && "function" == typeof editor.getDoc && editor.getDoc().defaultView;
            if (editor) {
                var range, editor = editor.getSelection();
                if (0 < editor.rangeCount) return range = editor.getRangeAt(0), 
                editor.removeAllRanges(), range;
            }
            return null;
        },
        removeCursorOnSafari: function(editor) {
            if (module.util.isSafari()) return module.util.removeCursor(editor);
        },
        setCursor: function(editor, range) {
            !range || (editor = editor.getDoc().defaultView) && editor.getSelection().addRange(range);
        },
        getNodeWidth: function(node) {
            var nodeType = node.nodeType;
            switch (nodeType) {
              case Node.ELEMENT_NODE:
                if ("BR" === node.nodeName) return 1;
                for (var children = node.childNodes, len = 0, i = 0; i < children.length; i++) len += module.util.getNodeWidth(children[i]);
                return len;

              case Node.ATTRIBUTE_NODE:
                return console.log("Attribute"), 0;

              case Node.TEXT_NODE:
                var text = node.data;
                return console.log("Text: " + text), text.length;

              case Node.CDATA_SECTION_NODE:
                return console.log("CDATA"), 0;

              case Node.PROCESSING_INSTRUCTION_NODE:
                return console.log("PI"), 0;

              case Node.COMMENT_NODE:
                return console.log("Comment"), 0;

              case Node.DOCUMENT_NODE:
                return console.log("Document"), 0;

              case Node.DOCUMENT_TYPE_NODE:
                return console.log("DocType"), 0;

              case Node.DOCUMENT_FRAGEMNT_NODE:
                return console.log("Fragement"), 0;

              default:
                return console.log("Oops: Unknow node type " + nodeType), 0;
            }
        },
        splitTextNode: function(node, pos) {
            return node.splitText(pos);
        }
    }, module;
}((DUDEN_CORRECTOR = function(module) {
    "use strict";
    var STATIC_SETTINGS = {
        hyphenation: !1,
        "correction-proposals": !0,
        "single-word-mode": !1,
        "markup-mode": "text",
        "message-language": "de-DE",
        "message-level": 2
    }, DYNAMICALLY_LOADED_SETTINGS = [ "text-language", "spellchecking-level", "orthography-standard", "property-sets" ];
    function DCSCorrector() {}
    return DCSCorrector.prototype.init = function(url, storage, options) {
        if (!url) throw new Error("No URL defined.");
        this.url = url, this.storage = storage, this.cache = new module.Cache(500), 
        this.proposalDictionary = options.proposalDictionary, this.dictionaries = options.dictionaries, 
        this.allowNestedErrors = options.allowNestedErrors;
    }, DCSCorrector.prototype.check = function(text, callbacks, temporarySettings, useCaching) {
        var dynamicSettings = {}, text = (DYNAMICALLY_LOADED_SETTINGS.forEach(function(key) {
            dynamicSettings[key] = this.storage.get(key);
        }.bind(this)), module.util.mergeObjects([ {
            text: text
        }, STATIC_SETTINGS, dynamicSettings, temporarySettings || {} ])), cacheKey = JSON.stringify(text);
        if (useCaching) {
            temporarySettings = this.readFromCache(cacheKey);
            if (temporarySettings) return callbacks.success(temporarySettings);
        }
        this.dictionaries && !text.dictionaries && (text.dictionaries = this.dictionaries);
        temporarySettings = this.getApiFunctionURL("check"), text = {
            method: "POST",
            data: text,
            success: function(data) {
                callbacks.success && (this.allowNestedErrors || (data["check-positions"] = this.removeNestedErrors(data["check-positions"])), 
                useCaching && this.writeToCache(cacheKey, data), callbacks.success(data));
            }.bind(this),
            error: function(data) {
                console.error("Server error while running check: " + data), callbacks.error(data);
            }
        };
        this.ajax(temporarySettings, text);
    }, DCSCorrector.prototype.removeNestedErrors = function(checkPositions) {
        for (var removedErrorIndices = [], i = 0; i < checkPositions.length - 1; i++) for (var j = i + 1; j < checkPositions.length; j++) {
            var firstError = checkPositions[i], secondError = checkPositions[j];
            this.checkPositionIncludes(firstError, secondError) ? removedErrorIndices.push(i) : this.checkPositionIncludes(secondError, firstError) && removedErrorIndices.push(j);
        }
        for (var newCheckPositions = [], i = 0; i < checkPositions.length; i++) -1 === removedErrorIndices.indexOf(i) && newCheckPositions.push(checkPositions[i]);
        return newCheckPositions;
    }, DCSCorrector.prototype.checkPositionIncludes = function(outerError, innerError) {
        return innerError.offset >= outerError.offset && innerError.offset + innerError.length <= outerError.offset + outerError.length;
    }, DCSCorrector.prototype.readFromCache = function(key) {
        key = this.cache.getItem(key);
        if (key) return JSON.parse(key);
    }, DCSCorrector.prototype.writeToCache = function(key, value) {
        value = JSON.stringify(value);
        this.cache.setItem(key, value);
    }, DCSCorrector.prototype.clearCache = function() {
        this.cache.clear();
    }, DCSCorrector.prototype.getVersion = function(options) {
        var url = this.getApiFunctionURL("version");
        this.ajax(url, options);
    }, DCSCorrector.prototype.getDictionaries = function(options) {
        var url = this.getApiFunctionURL("dictionaries");
        this.ajax(url, options);
    }, DCSCorrector.prototype.proposeWordForDictionary = function(word, callbacks) {
        this.dictionaries && -1 !== this.dictionaries.indexOf(this.proposalDictionary) && this.clearCache();
        var url = this.getApiFunctionURL("dictionaries/" + this.proposalDictionary + "/accept"), word = module.util.mergeObjects([ {
            data: this.proxy_without_parameter ? word : JSON.stringify({
                word: word
            }),
            method: "POST"
        }, callbacks ]);
        this.ajax(url, word);
    }, DCSCorrector.prototype.isProposalPending = function(word, callback) {
        this.check(word, {
            success: function(data) {
                data = 0 === data["check-positions"].length;
                callback(data);
            },
            error: function(data) {
                console.error(data), callback(!1);
            }
        }, {
            "single-word-mode": !0,
            "spellchecking-level": 1,
            dictionaries: [ this.proposalDictionary ],
            hyphenation: !1,
            "correction-proposals": !0
        }, !1);
    }, DCSCorrector.prototype.getApiFunctionURL = function(apiFunction) {
        if (apiFunction) return this.proxy_without_parameter ? this.url + "/" + apiFunction : this.url + "?function=" + apiFunction;
        throw new Error("No API function defined.");
    }, DCSCorrector.prototype.ajax = function(url, options) {
        var method = options.method || "GET", request = (options = options || {}, 
        new XMLHttpRequest());
        request.open(method, url, !0), request.setRequestHeader("Content-Type", "application/json"), 
        request.setRequestHeader("Accept", "application/json"), request.onerror = options.error, 
        request.onload = (() => {
            var data = request.responseText;
            try {
                200 <= request.status && request.status < 400 ? (data = JSON.parse(data), 
                options.success(this.proxy_without_parameter ? data : data.contents, request.status)) : (console.error("Invalid Status Code received.", data), 
                void 0 !== options.error && options.error(data));
            } catch (e) {
                console.error("Response is no valid JSON.", data), void 0 !== options.error && options.error(data);
            }
        }).bind(this), this.proxy_without_parameter ? request.send(JSON.stringify(options.data)) : ("object" == typeof (method = options.data) && (method = module.util.encodeObjectAsURIComponents(method)), 
        request.send(method));
    }, module.DCSCorrector = DCSCorrector, module;
}((DUDEN_CORRECTOR = function(module) {
    "use strict";
    function LocalStorage(defaultValues) {
        for (var key in this.storageCache = {}, defaultValues) null === this.get(key) && this.set(key, defaultValues[key]);
    }
    return LocalStorage.prototype.get = function(key) {
        if (void 0 !== this.storageCache[key]) return this.deserializeValue(this.storageCache[key]);
        var serializedValue = localStorage.getItem(key);
        return this.storageCache[key] = serializedValue, this.deserializeValue(serializedValue);
    }, LocalStorage.prototype.set = function(key, value) {
        value = this.serializeValue(value), this.storageCache[key] = value, localStorage.setItem(key, value);
    }, LocalStorage.prototype.update = function(newItems) {
        for (var key in newItems) newItems.hasOwnProperty(key) && this.set(key, newItems[key]);
    }, LocalStorage.prototype.serializeValue = function(value) {
        return JSON.stringify(value);
    }, LocalStorage.prototype.deserializeValue = function(serializedValue) {
        return JSON.parse(serializedValue);
    }, module.LocalStorage = LocalStorage, module;
}((DUDEN_CORRECTOR = function(module) {
    "use strict";
    function Cache(maxSize, debug, storage) {
        this.maxSize_ = maxSize || -1, this.debug_ = debug || !1, this.storage_ = storage || new Cache.BasicCacheStorage(), 
        this.fillFactor_ = .75, this.stats_ = {}, this.stats_.hits = 0, this.stats_.misses = 0, 
        this.log_("Initialized cache with size " + maxSize);
    }
    return Cache.Priority = {
        LOW: 1,
        NORMAL: 2,
        HIGH: 4
    }, (Cache.BasicCacheStorage = function() {
        this.items_ = {}, this.count_ = 0;
    }).prototype.get = function(key) {
        return this.items_[key];
    }, Cache.BasicCacheStorage.prototype.set = function(key, value) {
        void 0 === this.get(key) && this.count_++, this.items_[key] = value;
    }, Cache.BasicCacheStorage.prototype.size = function(key, value) {
        return this.count_;
    }, Cache.BasicCacheStorage.prototype.remove = function(key) {
        var item = this.get(key);
        return void 0 !== item && this.count_--, delete this.items_[key], item;
    }, Cache.BasicCacheStorage.prototype.keys = function() {
        var p, ret = [];
        for (p in this.items_) ret.push(p);
        return ret;
    }, (Cache.LocalStorageCacheStorage = function(namespace) {
        this.prefix_ = "cache-storage." + (namespace || "default") + ".";
        namespace = this.prefix_.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
        this.regexp_ = new RegExp("^" + namespace);
    }).prototype.get = function(key) {
        key = window.localStorage[this.prefix_ + key];
        return key ? JSON.parse(key) : null;
    }, Cache.LocalStorageCacheStorage.prototype.set = function(key, value) {
        window.localStorage[this.prefix_ + key] = JSON.stringify(value);
    }, Cache.LocalStorageCacheStorage.prototype.size = function(key, value) {
        return this.keys().length;
    }, Cache.LocalStorageCacheStorage.prototype.remove = function(key) {
        var item = this.get(key);
        return delete window.localStorage[this.prefix_ + key], item;
    }, Cache.LocalStorageCacheStorage.prototype.keys = function() {
        var p, ret = [];
        for (p in window.localStorage) p.match(this.regexp_) && ret.push(p.replace(this.prefix_, ""));
        return ret;
    }, Cache.prototype.getItem = function(key) {
        var item = this.storage_.get(key), item = (null != item && (this.isExpired_(item) ? (this.removeItem(key), 
        item = null) : item.lastAccessed = new Date().getTime()), item ? item.value : null);
        return item ? (this.stats_.hits++, this.log_("Cache HIT for key " + key)) : (this.stats_.misses++, 
        this.log_("Cache MISS for key " + key)), item;
    }, Cache._CacheItem = function(k, v, o) {
        if (!k) throw new Error("key cannot be null or empty");
        this.key = k, this.value = v, (o = o || {}).expirationAbsolute && (o.expirationAbsolute = o.expirationAbsolute.getTime()), 
        o.priority || (o.priority = Cache.Priority.NORMAL), this.options = o, this.lastAccessed = new Date().getTime();
    }, Cache.prototype.setItem = function(key, value, options) {
        var that;
        null != this.storage_.get(key) && this.removeItem(key), this.addItem_(new Cache._CacheItem(key, value, options)), 
        this.log_("Setting key " + key), 0 < this.maxSize_ && this.size() > this.maxSize_ && (that = this, 
        setTimeout(function() {
            that.purge_.call(that);
        }, 0));
    }, Cache.prototype.clear = function() {
        for (var keys = this.storage_.keys(), i = 0; i < keys.length; i++) this.removeItem(keys[i]);
        this.log_("Cache cleared");
    }, Cache.prototype.getStats = function() {
        return this.stats_;
    }, Cache.prototype.toHtmlString = function() {
        for (var returnStr = this.size() + " item(s) in cache<br /><ul>", keys = this.storage_.keys(), i = 0; i < keys.length; i++) var item = this.storage_.get(keys[i]), returnStr = returnStr + "<li>" + item.key.toString() + " = " + item.value.toString() + "</li>";
        return returnStr += "</ul>";
    }, Cache.prototype.resize = function(newMaxSize) {
        this.log_("Resizing Cache from " + this.maxSize_ + " to " + newMaxSize);
        var oldMaxSize = this.maxSize_;
        0 < (this.maxSize_ = newMaxSize) && (oldMaxSize < 0 || newMaxSize < oldMaxSize) && this.size() > newMaxSize && this.purge_(), 
        this.log_("Resizing done");
    }, Cache.prototype.purge_ = function() {
        for (var tmparray = new Array(), purgeSize = Math.round(this.maxSize_ * this.fillFactor_), keys = (this.maxSize_ < 0 && (purgeSize = this.size() * this.fillFactor_), 
        this.storage_.keys()), i = 0; i < keys.length; i++) {
            var key = keys[i], item = this.storage_.get(key);
            this.isExpired_(item) ? this.removeItem(key) : tmparray.push(item);
        }
        if (tmparray.length > purgeSize) for (tmparray = tmparray.sort(function(a, b) {
            return a.options.priority != b.options.priority ? b.options.priority - a.options.priority : b.lastAccessed - a.lastAccessed;
        }); tmparray.length > purgeSize; ) {
            var ritem = tmparray.pop();
            this.removeItem(ritem.key);
        }
        this.log_("Purged cached");
    }, Cache.prototype.addItem_ = function(item, attemptedAlready) {
        try {
            this.storage_.set(item.key, item);
        } catch (err) {
            if (attemptedAlready) throw this.log_("Failed setting again, giving up: " + err.toString()), 
            err;
            this.log_("Error adding item, purging and trying again: " + err.toString()), 
            this.purge_(), this.addItem_(item, !0);
        }
    }, Cache.prototype.removeItem = function(key) {
        var item = this.storage_.remove(key);
        return this.log_("removed key " + key), item && item.options && item.options.callback && setTimeout(function() {
            item.options.callback.call(null, item.key, item.value);
        }, 0), item ? item.value : null;
    }, Cache.prototype.removeWhere = function(test) {
        for (var keys = this.storage_.keys(), i = 0; i < keys.length; i++) {
            var key = keys[i];
            !0 === test(key, this.storage_.get(key).value) && this.removeItem(key);
        }
    }, Cache.prototype.size = function() {
        return this.storage_.size();
    }, Cache.prototype.isExpired_ = function(item) {
        var now = new Date().getTime(), expired = !1;
        return expired = !(expired = item.options.expirationAbsolute && item.options.expirationAbsolute < now ? !0 : expired) && item.options.expirationSliding && item.lastAccessed + 1e3 * item.options.expirationSliding < now ? !0 : expired;
    }, Cache.prototype.log_ = function(msg) {
        this.debug_ && console.log(msg);
    }, module.Cache = Cache, module;
}(DUDEN_CORRECTOR || {})) || {})) || {})) || {})) || {})) || {})) || {})) || {})) || {});
//# sourceMappingURL=plugin.js.map